/*
 ---------------------------------------------------------------
 Copyright (c) 2006, ixi software.
 This work is licensed under a Creative Commons 
 Attribution-NonCommercial-ShareAlike 2.0 England & Wales License.
 http://creativecommons.org/licenses/by-nc-sa/2.0/uk/
 --------------------------------------------------------------- 
 */


/*Lets have 100 circles. For this we need to have the instances in an array, otherwise we would need
to declare 100 variales to hold them

*/

import processing.opengl.*;

CircleBounce[] circles; // declare an array that will hold instances of CircleBounces class

    
void setup() { // just when starting up
  frameRate(20); // fps
  size(600, 400, OPENGL); // window size
  background(100); // bg color
  noStroke();
  //changeColor();
  
  circles = new CircleBounce[99]; // int the array to hold a max of 100 instances

  for (int i=0; i<circles.length; i++){ // 100 times
    circles[i] = new CircleBounce(200, 10, 100, 100, color(255, 0,0));// create instance into its slot in array circles
  }
}


color randRGB(){ // returns data type color
  return color(random(255), random(255), random(255));
}


void draw(){ // this is our main loop
  background(100);
  for (int i=0; i<circles.length; i++){ // 100 times
    circles[i].circleBounceDraw(); //draw each of them
  }
}


class CircleBounce{
  float x;
  float y;
  float w;
  float h;
  float deltaX = random(1,5);
  float deltaY = random(1,5);
  color c; // just declare because we are going to initialise it as a parameter

  CircleBounce(float ax, float ay, float aw, float ah, color aColor){ 
    // this is the constructor of the class, up to now it was hidden because we didnt need it
    x = ax;
    y = ay;
    w = aw;
    h = ah;
    c = aColor; // property c takes the value passed via parameter aColor when initialising the class instance
  }

  void changeMyColor(){
    c = randRGB();
  }

  void circleBounceDraw(){
    fill(c); // asign my color
    ellipse(x, y, w, h);
    // now we draw a red rect on top of our ellipses
    fill(255,0,0); //red color
    ellipse(x-(w/2), y, w/3, h/3); //left
    ellipse(x+(w/2), y, w/3, h/3); //right
    ellipse(x, y-(h/2), w/3, h/3); //top
    ellipse(x, y+(h/2), w/3, h/3); //bottom

    move(); // this way it is more tidy and neat
    checkBounce();

  }

  void move(){
    x = x + deltaX; 
    y = y + deltaY; 
  }

  void checkBounce(){
    if (x >= 600 || x <= 0){
      deltaX = -deltaX; //change X direction
      changeMyColor();
    }
    if (y >= 400 || y <= 0){
      deltaY = -deltaY; //change Y direction
      changeMyColor();
    }
  }
}


